//go:build webp

package convert

import (
	"bytes"
	"image"
	"os"
	"testing"

	"github.com/stretchr/testify/require"
)

func TestEncodeWebP(t *testing.T) {
	img := image.NewRGBA(image.Rect(0, 0, 10, 10))
	buf := new(bytes.Buffer)
	err := Encode(buf, WEBP, img)
	require.NoError(t, err)
}

func TestDecodeWebP(t *testing.T) {
	file, err := os.Open("testdata/1.webp")
	if err != nil {
		t.Fatal(err)
	}
	defer file.Close()
	_, ext, err := Decode(file)
	require.NoError(t, err)
	require.Equal(t, "webp", ext)
}
