package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/invitations"
	"git.perx.ru/perxis/perxis-go/pkg/invitations/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/invitations"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc invitations.Invitations, opts ...grpckit.ServerOption) pb.InvitationsServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		AcceptEndpoint: grpcerr.ServerMiddleware(eps.AcceptEndpoint),
		CreateEndpoint: grpcerr.ServerMiddleware(eps.CreateEndpoint),
		DeleteEndpoint: grpcerr.ServerMiddleware(eps.DeleteEndpoint),
		FindEndpoint:   grpcerr.ServerMiddleware(eps.FindEndpoint),
		GetEndpoint:    grpcerr.ServerMiddleware(eps.GetEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
